#ifndef GAMEOBJECTS_HPP_INCLUDED
#define GAMEOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/GameObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GameObjects
{
    public:

        static std::vector<Interactable::GameObject> GetAllWithin(std::int32_t Distance);

        static std::vector<Interactable::GameObject> GetAll();
        static std::vector<Interactable::GameObject> GetAll(const Tile& T);
        static std::vector<Interactable::GameObject> GetAll(std::int32_t ID, std::int32_t Distance = -1);
        static std::vector<Interactable::GameObject> GetAll(const std::string& Name, std::int32_t Distance = -1);
        static std::vector<Interactable::GameObject> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static std::vector<Interactable::GameObject> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static std::vector<Interactable::GameObject> GetAll(const std::function<bool (const Interactable::GameObject&)>& Filter, std::int32_t Distance = -1);

        static Interactable::GameObject Get(const Tile& T);
        static Interactable::GameObject Get(std::int32_t ID, std::int32_t Distance = -1);
        static Interactable::GameObject Get(const std::string& Name, std::int32_t Distance = -1);
        static Interactable::GameObject Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
        static Interactable::GameObject Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static Interactable::GameObject Get(const std::function<bool (const Interactable::GameObject&)>& Filter, std::int32_t Distance = -1);
};

/** @} */

#endif // GAMEOBJECTS_HPP_INCLUDED
